@import '~antd/lib/button/style/index.less';
@import '../../../theme/default.less';

@btn-prefix-cls: ~'@{ant-prefix}-btn';

.button-variant-fluantd(@color; @background; @border) {
  .button-color(@color; @background; @background);

  &:hover,
  &:focus {
    .button-color(
      @color; ~`colorPalette('@{background}', 5) `; ~`colorPalette('@{background}', 5) `
    );
  }

  &:active,
  &.active {
    .button-color(
      @color; ~`colorPalette('@{background}', 7) `; ~`colorPalette('@{background}', 7) `
    );
  }

  .button-disabled();
}

.button-disabled() {
  &.disabled,
  &[disabled] {
    &,
    &:hover,
    &:focus,
    &:active,
    &.active {
      .button-color(@btn-disable-color; @btn-disable-bg; @btn-disable-border) !important;
      text-shadow: none;
      box-shadow: none;
    }
  }
}

// Button styles
// -----------------------------
.@{btn-prefix-cls} {
  margin: 5px;
  line-height: @line-height-base;
  .btn;
  .btn-default;

  &-primary {
    .button-variant-fluantd(@btn-default-bg, @primary-color, @primary-color);
  }

  &-danger {
    .button-variant-fluantd(@btn-default-bg, @btn-danger-color, @btn-danger-border);
  }

  &-alert {
    .button-variant-fluantd(@text-color, @warning-color, @warning-color);
  }

  &-success {
    .button-variant-fluantd(@btn-default-bg, @success-color, @success-color);
  }

  &-rounded,
  &-rounded-outline {
    .btn-rounded(@btn-prefix-cls);
  }

  &-background-ghost&-success {
    .button-variant-ghost(@success-color);
  }

  &-background-ghost&-alert {
    .button-variant-ghost(@warning-color);
  }

  &-background-ghost&-danger {
    .button-variant-ghost(@btn-danger-color);
  }
}

.btn-rounded(@btnClassName: btn) {
  border-radius: @btn-circle-size;

  &.@{btnClassName}-lg {
    border-radius: (@btn-circle-size-lg);
  }

  &.@{btnClassName}-sm {
    border-radius: (@btn-circle-size-sm);
  }
}

.button-variant-ghost(@color) {
  .button-color(@color; transparent; @color);
  text-shadow: none;

  &:hover,
  &:focus {
    .button-color(
      ~`colorPalette('@{color}', 5) `; ~`colorPalette('@{color}', 1) `;
        ~`colorPalette('@{color}', 5) `
    ) !important;
  }

  &:active,
  &.active {
    .button-color(~`colorPalette('@{color}', 7) `; transparent; ~`colorPalette('@{color}', 7) `);
  }

  .button-disabled();
}

@btn-prefix-cls: ~'@{ant-prefix}-btn';

.button-variant-fluantd(@color; @background; @border) {
  .button-color(@color; @background; @background);

  &:hover,
  &:focus {
    .button-color(
      @color; ~`colorPalette('@{background}', 5) `; ~`colorPalette('@{background}', 5) `
    );
  }

  &:active,
  &.active {
    .button-color(
      @color; ~`colorPalette('@{background}', 7) `; ~`colorPalette('@{background}', 7) `
    );
  }

  .button-disabled();
}

.button-disabled() {
  &.disabled,
  &[disabled] {
    &,
    &:hover,
    &:focus,
    &:active,
    &.active {
      .button-color(@btn-disable-color; @btn-disable-bg; @btn-disable-border) !important;
      text-shadow: none;
      box-shadow: none;
    }
  }
}

// Button styles
// -----------------------------
.@{btn-prefix-cls} {
  margin: 5px;
  line-height: @line-height-base;
  .btn;
  .btn-default;

  &-primary {
    .button-variant-fluantd(@btn-default-bg, @primary-color, @primary-color);
  }

  &-danger {
    .button-variant-fluantd(@btn-default-bg, @btn-danger-color, @btn-danger-border);
  }

  &-alert {
    .button-variant-fluantd(@text-color, @warning-color, @warning-color);
  }

  &-success {
    .button-variant-fluantd(@btn-default-bg, @success-color, @success-color);
  }

  &-rounded,
  &-rounded-outline {
    .btn-rounded(@btn-prefix-cls);
  }

  &-background-ghost&-success {
    .button-variant-ghost(@success-color);
  }

  &-background-ghost&-alert {
    .button-variant-ghost(@warning-color);
  }

  &-background-ghost&-danger {
    .button-variant-ghost(@btn-danger-color);
  }
}

.btn-rounded(@btnClassName: btn) {
  border-radius: @btn-circle-size;

  &.@{btnClassName}-lg {
    border-radius: (@btn-circle-size-lg);
  }

  &.@{btnClassName}-sm {
    border-radius: (@btn-circle-size-sm);
  }
}

.button-variant-ghost(@color) {
  .button-color(@color; transparent; @color);
  text-shadow: none;

  &:hover,
  &:focus {
    .button-color(
      ~`colorPalette('@{color}', 5) `; ~`colorPalette('@{color}', 1) `;
        ~`colorPalette('@{color}', 5) `
    ) !important;
  }

  &:active,
  &.active {
    .button-color(~`colorPalette('@{color}', 7) `; transparent; ~`colorPalette('@{color}', 7) `);
  }

  .button-disabled();
}
